
/**
 * Testovaci trida LoukaTest ... doplnte vlastni komentar
 *
 * @author     jmeno autora
 * @version    cislo verze, datum
 */
public class LoukaTest extends junit.framework.TestCase
{

    /**
     * Konstruktor umoznujici spustit definovany test.
     */
    public LoukaTest( String nazevTestu )
    {
        super( nazevTestu );
    }


    /**
     * Vytvoreni pripravku (fixture), tj. sady objektu, s nimiz budou vsechny
     * testy pracovat a ktera se proto vytvori pred spustenim kazdeho testu.         
     */
    protected void setUp()
    {
    }


    /**
     * Uklid po testu - tato metoda se spusti po vykonani kazdeho testu.
     */
    protected void tearDown()
    {
    }

	public void testRadekSloupec()
	{
		Louka louka1 = new Louka(10, 12);
		assertEquals(10, louka1.getDelka());
		assertEquals(12, louka1.getSirka());
	}

	public void testVlozOdeber() {
		Louka louka = new Louka(10, 10);
		Pozice pozice = najdiPozici(louka, 3, 3);
		assertNull("pozice by měla být prázdná", louka.getObjectAt(pozice));
		Kralik kralik = new Kralik(false);
		louka.vloz(kralik, pozice);
		assertEquals("na pozici by měl být králík", kralik, louka.getObjectAt(pozice));
		louka.odeberZvire(pozice);
		assertNull("po odebrání by pozice měla být prázdná", louka.getObjectAt(pozice));		
	}

	public void testPresun() {
		Louka louka = new Louka(10, 10);
		Pozice pozice = najdiPozici(louka, 3, 3);
		assertNull("pozice by měla být prázdná", louka.getObjectAt(pozice));
		Kralik kralik = new Kralik(false);
		louka.vloz(kralik, pozice);
		assertEquals("na pozici by měl být králík", kralik, louka.getObjectAt(pozice));
		Pozice novaPozice = najdiPozici(louka, 2, 2);
		louka.presun(kralik, pozice, novaPozice);
		assertNull("po odebrání by pozice měla být prázdná", louka.getObjectAt(pozice));		
		assertEquals("na nové pozici by měl být králík", kralik, louka.getObjectAt(novaPozice));
	}

	public void testSousedniPozice() {
		Louka louka = new Louka(10, 10);
		Pozice pozice = najdiPozici(louka, 9, 9);
		assertEquals(" [9, 9] - měly by být 3 sousední pozice", 3, louka.sousedniPozice(pozice).size());
		pozice = najdiPozici(louka, 4, 9);
		assertEquals(" [4, 9] - mělo by být 5 sousedních pozic", 5, louka.sousedniPozice(pozice).size());
		pozice = najdiPozici(louka, 3, 3);
		assertEquals(" [3, 3] - mělo by být 8 sousedních pozic", 8, louka.sousedniPozice(pozice).size());
	}

	public void testVolneSousedniPozice() {
		Louka louka = new Louka(10, 10);
		Pozice pozice = najdiPozici(louka, 9, 9);
		assertEquals(" [9, 9] - měly by být 3 sousední pozice", 3, louka.sousedniPozice(pozice).size());
		Kralik kralik1 = new Kralik(false);
		Kralik kralik2 = new Kralik(false);
		Kralik kralik3 = new Kralik(false);
		Kralik kralik4 = new Kralik(false);
		louka.vloz(kralik1, najdiPozici(louka,8,9));
		louka.vloz(kralik2, najdiPozici(louka,8,8));
		assertEquals("měla by být volná pozice [9,8]", najdiPozici(louka,9,8), louka.volnaSousedniPozice(pozice));
		louka.vloz(kralik3, najdiPozici(louka,9,8));
		assertEquals("měla by být volná pozice [9,9]", najdiPozici(louka,9,9), louka.volnaSousedniPozice(pozice));
		louka.vloz(kralik4, najdiPozici(louka,9,9));
		assertNull("nyní by již neměla být žádná volná pozice", louka.volnaSousedniPozice(pozice));
	}
	
	private Pozice najdiPozici(Louka louka, int radek, int sloupec) {
	    for (Pozice pozice : louka.seznamPozic()) {
	        if (pozice.getRadek() == radek && pozice.getSloupec() == sloupec) {
	            return pozice;
	        }
	    }
	    return null;
	}
}


