/**
 * Reprezentuje pozici v pravoúhlé mřížce.
 * 
 * @author David J. Barnes and Michael Kolling
 * @author Lubos Pavlicek
 * @version 2005.10.23
 */
public class Pozice {

    private int radek;
    private int sloupec;

    /**
     * Reprezentuje řádek a sloupec.
     * @param radek     Řádek.
     * @param sloupec   Sloupec.
     */
    public Pozice(int radek, int sloupec) {
        this.radek = radek;
        this.sloupec = sloupec;
    }
    
    /**
     * Implementace metody equals().
     */
    public boolean equals(Object obj) {
        if(obj instanceof Pozice) {
            Pozice druha = (Pozice) obj;
            return radek == druha.getRadek() && sloupec == druha.getSloupec();
        }
        else {
            return false;
        }
    }
    
    /**
     * Vrací řetězec ve formátu radek,sloupec
     * @return Řetězec reprezentující pozici.
     */
    public String toString() {
        return radek + "," + sloupec;
    }
    
    /**
     * Vrací hashCode pro pozici. Do prvních 16 bitů se umístí řádek, do druhých
     * se umístí sloupec. S výjimkou velmi velkých ploch je
     * výsledný hashCode pro dvojici (radek,sloupec) unikátní.
     * @return A hashcode for the location.
     */
    public int hashCode() {
        return (radek << 16) + sloupec;
    }
    
    /**
     * @return Řádek.
     */
    public int getRadek() {
        return radek;
    }
    
    /**
     * @return Sloupec.
     */
    public int getSloupec() {
        return sloupec;
    }
}
